package com.example.hello.comp;

import org.svvrl.goal.core.FinishedException;
import org.svvrl.goal.core.aut.Automaton;
import org.svvrl.goal.core.aut.OmegaUtil;
import org.svvrl.goal.core.aut.fsa.FSA;
import org.svvrl.goal.gui.ProgressDialog;
import org.svvrl.goal.gui.Window;
import org.svvrl.goal.gui.action.AutomatonOperationAction;
import org.svvrl.goal.gui.action.ExecutionException;

public class HelloComplementAction extends AutomatonOperationAction<FSA, FSA> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 609781865688630675L;

	public HelloComplementAction(Window win) {
		super(win, "Hello Complement");
	}

	@Override
	public String getToolTip() {
		return "Complement an NBW by a buggy algorithm.";
	}

	@Override
	public boolean isApplicable(Automaton aut) {
		return OmegaUtil.isNBW(aut);
	}

	@Override
	public FSA execute(ProgressDialog dialog) throws ExecutionException,
			FinishedException {
		FSA aut = new HelloConstruction(getInput().clone()).complement();
		return aut;
	}

}
