package com.example.hello.comp;

import org.svvrl.goal.core.Editable;
import org.svvrl.goal.core.Message;
import org.svvrl.goal.core.aut.BuchiAcc;
import org.svvrl.goal.core.aut.OmegaUtil;
import org.svvrl.goal.core.aut.State;
import org.svvrl.goal.core.aut.StateSet;
import org.svvrl.goal.core.aut.fsa.FSA;
import org.svvrl.goal.core.comp.ComplementConstruction;

public class HelloConstruction extends ComplementConstruction<FSA, FSA> {

	private FSA complement = null;

	public HelloConstruction(FSA aut) {
		super(aut);

		if (!OmegaUtil.isNBW(aut))
			throw new IllegalArgumentException(
					Message.onlyForFSA(BuchiAcc.class));
	}

	@Override
	public Editable getIntermediateResult() {
		return complement;
	}

	private void dual(BuchiAcc acc) {
		StateSet states = new StateSet(getInput().getStates());
		states.removeAll(acc.get());
		acc.clear();
		for (State s : states)
			acc.add(s);
	}

	@Override
	public FSA complement() {
		if (complement != null)
			return complement;

		FSA input = getInput();
		complement = input.clone();
		fireReferenceChangedEvent();
		dual((BuchiAcc) complement.getAcc());

		return complement;
	}

}
